package com.exh.bevel.render;

import com.exh.math.primitive.Point3;
import com.exh.math.primitive.Tri;

/* Wrap up a tri with normal information.
 */
public final class Surface {
	
	public final Tri			mTri;
	public Point3				mNormal = new Point3();

	public double				mL, mT, mR, mB;
	
	public Surface(final Tri t) {
		mTri = t;
		
		mL = mR = mTri.mPt[0].x;
		mT = mB = mTri.mPt[0].y;
		for (int k=1; k<mTri.mPt.length; k++) {
			final Point3		pt = mTri.mPt[k];
			mL = Math.min(mL, pt.x);
			mT = Math.min(mT, pt.y);
			mR = Math.max(mR, pt.x);
			mB = Math.max(mB, pt.y);
		}
	}

}
