package com.exh.math.poly;

/* Store a single edge in one of the source polygons, with information
 * about whether it's valid or not.
 */
final class Edge {

	Step			mA, mB;
	// Use the alignment values from the Step
	int				mAlignment;
	
	// Debugging!
	String			mAName, mBName;
	
	void set(	final Step a, final Step b, final EvilDoer evil,
				final String aName, final String bName) {
		mA = a;
		mB = b;
		mAlignment = Step.GOOD;
		if (mA.mAlignment < Step.NEUTRAL || mB.mAlignment < Step.NEUTRAL) mAlignment = Step.EVIL;
		if (evil != null) evil.on(this);
		
		mAName = aName;
		mBName = bName;
	}
	
	String getAlignName() {
		if (mAlignment == Step.GOOD) return "GOOD";
		if (mAlignment == Step.NEUTRAL) return "NEUTRAL";
		if (mAlignment == Step.EVIL) return "EVIL";
		return Integer.toString(mAlignment);
	}
}
