package com.exh.math.poly;

final class EdgeList {

	Edge[]				mEdge = null;
	int					mSize = 0;

	EdgeList() {
		growTo(16);
	}
	
	// Set myself to the edges of steplist a, using b to determine
	// which edges should be marked as EVIL.  Set forward to false if
	// you want to iterate in the reverse order (this is for lists
	// that should be built backwards).
	boolean start(	final StepList a, final StepList b, final boolean forward,
					final EvilDoer evil, final String prefix) {
		mSize = 0;
		if (a.mSize < 2) return false;
		if (mEdge.length < a.mSize) growTo(a.mSize+8);
		
		int				first, last, stop, inc;
		if (forward) {
			first = 0;
			last = a.mSize-1;
			stop = a.mSize;
			inc = 1;
		} else {
			first = a.mSize-1;
			last = 0;
			stop = -1;
			inc = -1;
		}
		
		if (Bool.TESTING_BUILD) System.out.println("Bulid edges for " + prefix);
		Step			prv = a.mStep[last];
		int				prvK = last;
		int				dstK = 0;
		for (int k = first; k != stop; k += inc) {
			final Step	nxt = a.mStep[k];
			mEdge[dstK].set(prv, nxt, evil, prefix+prvK, prefix+k);
			if (Bool.TESTING_BUILD) System.out.println("\tedge " + dstK + " " + mEdge[dstK].mAName + " to " + mEdge[dstK].mBName + " =" + mEdge[dstK].getAlignName());
		
			prv = nxt;
			prvK = k;
			dstK++;
		}
		
		mSize = a.mSize;
		return true;
	}

	
	int findIndexForA(final Intersection inter) {
		for (int k=0; k<mSize; k++) {
			final Edge		e = mEdge[k];
			if (e.mA.mIntersection == inter) return k;
		}
		return -1;
	}

	private void growTo(final int newLength) {
		if (mEdge == null || newLength > mEdge.length) {
			final Edge[]		newEdge = new Edge[newLength];
			final int			oldLength = (mEdge != null ? mEdge.length : 0);
			if (oldLength > 0) System.arraycopy(mEdge, 0, newEdge, 0, mEdge.length);
			for (int k=oldLength; k<newLength; k++) newEdge[k] = new Edge();
			mEdge = newEdge;
		}
	}
}
