package com.exh.math.poly;

import com.exh.math.primitive.Point3;

/* Store a single intersection, which means its point
 * and the segments that created it.  I own the point,
 * but not the segment points
 */
class Intersection {

	final Point3		mPt = new Point3(0, 0, 0);
	Point3[]			mA = new Point3[2],
						mB = new Point3[2];
	
	void clear() {
		for (int k=0; k<mA.length; k++) mA[k] = null;
		for (int k=0; k<mB.length; k++) mB[k] = null;
	}

	void set(	final Point3 pt,
				final Point3 a0, final Point3 a1,
				final Point3 b0, final Point3 b1) {
		mPt.set(pt);
		mA[0] = a0;
		mA[1] = a1;
		mB[0] = b0;
		mB[1] = b1;
	}
	
	public String toString() {
		return mPt.toString();
	}
}
