package com.exh.math.primitive;


public class Plane {

	public final Point3			mPt = new Point3(),
								mN = new Point3();
	
	public Plane() {
	}
	
	public final void from(final Tri t) {
		final Point3	a = t.mPt[0], b = t.mPt[1], c = t.mPt[2];

		mPt.set(a);

		// get triangle edge vectors and plane normal
		final Point3	u = new Point3(), v = new Point3();
		u.sub(b, a);
		v.sub(c, a);
		mN.asCrossProduct(u, v);
	}
	
	// Kind of dicey, but the framework requires that polygons be on
	// the same plane.  Not sure if it might be necessary to do some
	// work to pick non-parallel sides, or if point order matters.
	public final boolean from(final Polygon p) {
		if (p.mSize < 3) return false;
		final Point3	a = p.mPt[0], b = p.mPt[1], c = p.mPt[2];

		mPt.set(a);

		// get triangle edge vectors and plane normal
		final Point3	u = new Point3(), v = new Point3();
		u.sub(b, a);
		v.sub(c, a);
		mN.asCrossProduct(u, v);
		return true;
	}
}
