package com.exh.math.primitive;

public class Segment {
	
	public final Point3[]				mPt = Point3.newArray(2);

	public Segment() {
	}
	
	public Segment(final Segment seg) {
		for (int k=0; k<mPt.length; k++) mPt[k].set(seg.mPt[k]);
	}

	public double getCenterX() {
		return (mPt[0].x + mPt[1].x) / 2;
	}

	public double getCenterY() {
		return (mPt[0].y + mPt[1].y) / 2;
	}
	
	public void set(final Point3 a, final Point3 b) {
		mPt[0].set(a);
		mPt[1].set(b);
	}
	
	public void set(final Segment s) {
		for (int k=0; k<mPt.length; k++) mPt[k].set(s.mPt[k]);
	}
	
	public void reverse() {
		final Point3		pt = mPt[0];
		mPt[0] = mPt[1];
		mPt[1] = pt;
	}
	
	public String toString() {
		return mPt[0] + " " + mPt[1];
	}

	// ITERATOR
	// -------------------------------------
	public final static class Iterator {
		
		private Point3[]		mPt = null;
		private int				mSize = 0;
		private Point3			mPrev = null;
		private int				mIdx = 0;
		
		// Begin iterating on a list that we will naturally
		// connect the last point to the first (i.e. a closed shape).
		public void beginClosed(final Point3[] pt, final int size) {
			mPt = pt;
			mSize = size;
			mPrev = mPt[mSize-1];
			mIdx = 0;
		}
		
		public boolean next(final Segment seg) {
			if (mIdx >= mSize || mPrev == null) return false;
			
			seg.mPt[0] = mPrev;
			mPrev = mPt[mIdx];
			seg.mPt[1] = mPrev;
			mIdx++;
			return true;
		}
	}

}
