package com.exh.math.primitive;


public class Tri {

	public final static int		SIZE = 3;

	public static final Tri		create(final Point3 a, final Point3 b, final Point3 c) {
		return new Tri(a, b, c);
	}
	
	public final Point3[]		mPt = newPts(SIZE);
	
	public Tri() {
	}
	
	public Tri(final Point3 a, final Point3 b, final Point3 c) {
		mPt[0].set(a);
		mPt[1].set(b);
		mPt[2].set(c);
	}
	
	public Tri copy() {
		return new Tri(mPt[0], mPt[1], mPt[2]);
	}
	
	public void set(final double ax, final double ay, final double az,
					final double bx, final double by, final double bz,
					final double cx, final double cy, final double cz) {
		mPt[0].set(ax, ay, az);
		mPt[1].set(bx, by, bz);
		mPt[2].set(cx, cy, cz);
	}

	public void getBarycenter(final Point3 bary) {
		Geo.getBarycenter(mPt, SIZE, bary);
	}

	// Answer true if my x, y bounding frames (ignoring z) overlap.
	public boolean xyFramesOverlap(final Tri o) {
		final Point3		a0 = mPt[0], b0 = mPt[1], c0 = mPt[2],
							a1 = o.mPt[0], b1 = o.mPt[1], c1 = o.mPt[2];
		if (Math.max(a0.x, Math.max(b0.x, c0.x)) < Math.min(a1.x, Math.min(b1.x, c1.x))) return false;
		if (Math.max(a0.y, Math.max(b0.y, c0.y)) < Math.min(a1.y, Math.min(b1.y, c1.y))) return false;
		if (Math.min(a0.x, Math.min(b0.x, c0.x)) > Math.max(a1.x, Math.max(b1.x, c1.x))) return false;
		if (Math.min(a0.y, Math.min(b0.y, c0.y)) > Math.max(a1.y, Math.max(b1.y, c1.y))) return false;
		return true;
	}

	public String toString() {
		return mPt[0].toString() + ", " + mPt[1].toString() + ", " + mPt[2].toString();
	}

	public final static Point3[] newPts(final int size) {
		final Point3[]		ans = new Point3[size];
		for (int k=0; k<size; k++) ans[k] = new Point3();
		return ans;
	}
}
