package com.exh.math.tests;

import com.exh.math.primitive.Geo;
import com.exh.math.primitive.Point3;
import com.exh.math.primitive.Segment;

// Tests if two 3D lines (or segments) are colinear by verifying that
// the end points of one are on the other.  This should be an easy check
// in 2d, but this is the best way I can think to do it in 3d.
public class LineIsColinear {

	public double				mEps = Geo.EPS;
	
	private final PtToLine		mPtL = new PtToLine();
	
	public boolean on(final Segment a, final Segment b) {
		return on(a.mPt[0], a.mPt[1], b.mPt[0], b.mPt[1]);
	}
	
	public boolean on(	final Point3 a0, final Point3 a1,
						final Point3 b0, final Point3 b1) {
		return mPtL.on(a0, b0, b1, null) <= mEps
				&& mPtL.on(a1, b0, b1, null) <= mEps;
	}
}
