package com.exh.math.tests;

import com.exh.math.primitive.Geo;
import com.exh.math.primitive.Point3;

// Given a line a pt and a line segment defined by A-B,
// find the nearest point on the segment and answer the distance.
// This is in 2D.
public final class NearestToSeg {
	
	private final Point3		mV = new Point3(),
								mW = new Point3();
	
	public double on(	final Point3 pt,
						final Point3 a, final Point3 b,
						final Point3 nearest) {
		mV.sub(b, a);
		mW.sub(pt, a);

		final double	c1 = mW.dot2d(mV);
		if (c1 <= 0) {
			if (nearest != null) nearest.set(a);
			return Geo.dist(pt.x, pt.y, a.x, a.y);
		}
		
		final double	c2 = mV.dot2d(mV);
		if (c2 <= c1) {
			if (nearest != null) nearest.set(b);
			return Geo.dist(pt.x, pt.y, b.x, b.y);
		}
	
		final double	d = c1/c2;
		mV.x = (mV.x * d) + a.x;
		mV.y = (mV.y * d) + a.y;
		if (nearest != null) nearest.set(mV);
		return Geo.dist(pt.x, pt.y, mV.x, mV.y);
	}

	// Answer the distance squared.
	public double onSquared(final Point3 pt,
							final Point3 a, final Point3 b,
							final Point3 nearest) {
		mV.sub(b, a);
		mW.sub(pt, a);

		final double	c1 = mW.dot2d(mV);
		if (c1 <= 0) {
			if (nearest != null) nearest.set(a);
			return Geo.distSquared(pt.x, pt.y, a.x, a.y);
		}
		
		final double	c2 = mV.dot2d(mV);
		if (c2 <= c1) {
			if (nearest != null) nearest.set(b);
			return Geo.distSquared(pt.x, pt.y, b.x, b.y);
		}
	
		final double	d = c1/c2;
		mV.x = (mV.x * d) + a.x;
		mV.y = (mV.y * d) + a.y;
		if (nearest != null) nearest.set(mV);
		return Geo.distSquared(pt.x, pt.y, mV.x, mV.y);
	}

}
