package com.exh.math.tests;

import com.exh.math.primitive.Point3;

public final class PtInTri {

	private final Point3		mU = new Point3(),
								mV = new Point3(),
								mCp1 = new Point3(),
								mCp2 = new Point3();
	
	// Answer true if the point lies in triangle ABC.  This works
	// in 3d (provided the point and triangle are on the same plane).
	public boolean on(final Point3 pt, Point3 a, Point3 b, Point3 c) {
		return sameSide(pt, a, b, c)
				&& sameSide(pt, b, a, c)
				&& sameSide(pt, c, a, b);
	}
	
	private boolean sameSide(final Point3 p1, Point3 p2, Point3 a, Point3 b) {
		mU.sub(b, a);
		mV.sub(p1, a);
		mCp1.asCrossProduct(mU, mV);
		mV.sub(p2, a);
		mCp2.asCrossProduct(mU, mV);
		return mCp1.dot3(mCp2) >= 0;
	}
}
