package com.exh.math.tests;

import com.exh.math.primitive.Point3;
import com.exh.math.primitive.Segment;

// Distance from point to unbounded line, 3D
// from http://http://www.softsurfer.com/Archive/algorithm_0102/
public class PtToLine {

	private final Point3		mV = new Point3(),
								mW = new Point3(),
								mPb = new Point3();
	
	public double on(final Point3 pt, final Segment seg, final Point3 out) {
		return on(pt, seg.mPt[0], seg.mPt[1], out);
	}

	public double on(final Point3 pt, final Point3 a0, final Point3 a1, final Point3 out) {
		mV.sub(a1, a0);
		mW.sub(pt, a0);
		
		final double		c1 = mW.dot3(mV),
							c2 = mV.dot3(mV);
		final double		b = c1 / c2;
		
		mV.mult(b);
		mPb.add(a0, mV);
		if (out != null) out.set(mPb);
		return pt.dist3(mPb);
	}

}
