package com.exh.math.tests;

import com.exh.math.primitive.Point3;

public class PtToPoly {

	private final NearestToSeg		mPtS = new NearestToSeg();
	
	public double on(	final Point3[] poly, final int polySize,
						final Point3 pt) {
		if (polySize < 1) return -1;
		return Math.sqrt(onSquared(poly, polySize, pt));
	}
	
	public double onSquared(final Point3[] poly, final int polySize,
							final Point3 pt) {
		if (polySize < 1) return -1;
		Point3				prv = poly[polySize-1];
		double				min = mPtS.onSquared(pt, prv, poly[0], null);
		for (int k=0; k<polySize; k++) {
			final Point3	ep = poly[k];
			final double	d = mPtS.onSquared(pt, prv, ep, null);
			if (d < min) min = d;
			prv = ep;
		}
		return min;
	}

}
