package com.exh.math.tests;

import com.exh.math.primitive.Point3;
import com.exh.math.primitive.Segment;

// http://softsurfer.com/Archive/algorithm_0106/algorithm_0106.htm#dist3D_Segment_to_Segment()

public final class SegSeg {

	public double					mDistanceToHit;
	public final Point3				mHit = new Point3();

	// Clients can set the distance amount that determines a hit.
	public double					mEps = EPS;
	
public final LineLine			mLL = new LineLine();
//	private final LineLine			mLL = new LineLine();
	private final PtToSeg3			mPS = new PtToSeg3();
	
/*
	private final Point3			mU = new Point3(),
									mV = new Point3(),
									mW = new Point3(),
									mY = new Point3(),
									mDp = new Point3();
*/
//	private final static double		EPS = 0.0000000001;
	private final static double		EPS = 0.00001;

	// Given two segments, answer true if they intersect, otherwise false.
	// If true, mDistanceToHit and mHit will be valid.
	public boolean on(final Segment S1, final Segment S2) {
		return on(S1.mPt[0], S1.mPt[1], S2.mPt[0], S2.mPt[1]);
	}

	public boolean on2(	final Point3 a1, final Point3 a2,
						final Point3 b1, final Point3 b2) {
		// First see if the unbounded lines intersect.
		if (!mLL.on2(a1, a2, b1, b2)) return false;
//System.out.println("distance=" + mDistanceToHit + " eps=" + mEps);
		// Then make sure the point is on both segments.  We
		// treat the point nearest to the first segment as
		// "canonical."
//System.out.println("\tps a=" + mPS.on(mLL.mNearest1, a1, a2, null));
		if (mPS.on(mLL.mNearestA, a1, a2, null) >= mEps) return false;
		mHit.set(mLL.mNearestA);
//System.out.println("\tps b=" + mPS.on(mLL.mNearest1, b1, b2, null));
		return mPS.on(mLL.mNearestA, b1, b2, null) < mEps;
	}
	
	public boolean on(	final Point3 a1, final Point3 a2,
						final Point3 b1, final Point3 b2) {
		// First see if the unbounded lines intersect.
		mDistanceToHit = mLL.on(a1, a2, b1, b2);
//System.out.println("distance=" + mDistanceToHit + " eps=" + mEps);
		if (mDistanceToHit >= mEps) return false;
		// Then make sure the point is on both segments.  We
		// treat the point nearest to the first segment as
		// "canonical."
//System.out.println("\tps a=" + mPS.on(mLL.mNearest1, a1, a2, null));
		if (mPS.on(mLL.mNearest1, a1, a2, null) >= mEps) return false;
		mHit.set(mLL.mNearest1);
//System.out.println("\tps b=" + mPS.on(mLL.mNearest1, b1, b2, null));
		return mPS.on(mLL.mNearest1, b1, b2, null) < mEps;
		
// OK, this is no doubt faster, but finding the actual intersection
// point does not work...  hmmm.
// XXX actually this is probably fine -- issue I was hitting was
// something weird where two tris weren't acting the same as the
// quad they came from
/*
		mU.sub(a2, a1);
		mV.sub(b2, b1);
		mW.sub(a1, b1);
		final double	a = mU.dot3(mU),
						b = mU.dot3(mV),
						c = mV.dot3(mV),
						d = mU.dot3(mW),
						e = mV.dot3(mW);
		final double	D = a*c - b*b;
		double			sc, sN, sD = D,
						tc, tN, tD = D;

		// compute the line parameters of the two closest points
		if (D < EPS) {			// the lines are almost parallel
			sN = 0.0;			// force using point P0 on segment S1
			sD = 1.0;			// to prevent possible division by 0.0 later
			tN = e;
			tD = c;
		} else {                // get the closest points on the infinite lines
			sN = (b*e - c*d);
			tN = (a*e - b*d);
			if (sN < 0.0) {       // sc < 0 => the s=0 edge is visible
				sN = 0.0;
				tN = e;
				tD = c;
			} else if (sN > sD) {  // sc > 1 => the s=1 edge is visible
				sN = sD;
				tN = e + b;
				tD = c;
			}
		}

		if (tN < 0.0) {           // tc < 0 => the t=0 edge is visible
			tN = 0.0;
			// recompute sc for this edge
			if (-d < 0.0) sN = 0.0;
			else if (-d > a) sN = sD;
			else {
				sN = -d;
				sD = a;
			}
		} else if (tN > tD) {      // tc > 1 => the t=1 edge is visible
			tN = tD;
			// recompute sc for this edge
			if ((-d + b) < 0.0) sN = 0;
			else if ((-d + b) > a) sN = sD;
			else {
				sN = (-d + b);
				sD = a;
			}
		}

		// finally do the division to get sc and tc
		sc = (Math.abs(sN) < EPS ? 0.0 : sN / sD);
		tc = (Math.abs(tN) < EPS ? 0.0 : tN / tD);

		// The hit point
		mHit.sub(a1, mU);
//		mPt1.sub(b2, mV);

	    // get the difference of the two closest points
	    mU.mult(sc);
	    mV.mult(tc);
	    mY.sub(mU, mV);
	    mDp.add(mW, mY);
//	    Vector   dP = w + (sc * u) - (tc * v);  // = S1(sc) - S2(tc)

		// return the closest distance
		mDistanceToHit = mDp.length();
		return mDistanceToHit < EPS;
*/
	}

}